︠24b61716-0800-4813-a921-7b6efafcac1bsi︠
from itertools import combinations
vxs = range(5)
edges = [(0,1,None),(0,2,None),(0,3,None),(0,4,None),(1,2,None),(2,3,None),(3,4,None),(4,1,None),(1,3,'E'),(2,4,'N')]
g=Graph()
g.add_vertices(vxs)
g.add_edges(edges)
g.set_pos({0:(pi,pi),1:(3*pi/2,pi),2:(pi,3*pi/2),3:(pi/2,pi),4:(pi,pi/2)})
var('t u v')
def parametrized(p,q):
    x1,y1 = p
    x2,y2 = q
    return (t*x2 + (1-t)*x1, t*y2+(1-t)*y1)

def edge_curves(g):
    curves = []
    pos = g.get_pos()
    for u,v,l in g.edges():
        if l is None:
            curves.append(parametrized(pos[u],pos[v]))
        else:
            if l=='E':
                curves.append(parametrized(pos[1],(5*pi/2,pi)))
            elif l=='N':
                curves.append(parametrized(pos[2],(pi,5*pi/2)))
    return curves

a,b = 2,1
x = (a + b*cos(u))*cos(v)
y = (a + b*cos(u))*sin(v)
z = b*sin(u)

curve=Graphics()
for c in edge_curves(g):
    s = [_.subs(dict(zip((u,v),c))) for _ in (x,y,z)]
    curve += parametric_plot(s,(t,0,1),color='red',thickness=2,plot_points=400)
pos = g.get_pos()
for w in g:
    x0,y0 = pos[w]
    x1 = (a + b*cos(x0))*cos(y0)
    y1 = (a + b*cos(x0))*sin(y0)
    z1 = b*sin(x0)
    curve += point3d((x1,y1,z1),color='blue',size=10)
T = parametric_plot3d([x,y,z], (u,0,2*pi),(v,0,2*pi), opacity=.6,aspect_ratio=1)
T+curve
︡558011ae-07a4-4223-987b-bf5f3e8e870f︡{"stdout":"(t, u, v)\n"}︡{"file":{"filename":"b44d6b63-4458-4ef7-913f-4f91e69930e4.sage3d","uuid":"b44d6b63-4458-4ef7-913f-4f91e69930e4"}}︡{"done":true}︡
︠9ee19d37-63f6-4052-a57c-f535be4101cf︠









